# Copyright 2013-2024 Richard Pausch, Felix Schmitt, Axel Huebl, Finn-Ole Carstens
#
# This file is part of PIConGPU.
#
# PIConGPU is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# PIConGPU is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with PIConGPU.
# If not, see <http://www.gnu.org/licenses/>.
#

##
## This configuration file is used by PIConGPU's TBG tool to create a
## batch script for PIConGPU runs. For a detailed description of PIConGPU
## configuration files including all available variables, see
##
##                      docs/TBG_macros.cfg
##


#################################
## Section: Required Variables ##
#################################

TBG_wallTime="48:00:00"

TBG_devices_x=1
TBG_devices_y=1
TBG_devices_z=1

TBG_gridSize="128 1536 128"
TBG_steps="50"

TBG_periodic="--periodic 1 0 1"


#################################
## Section: Optional Variables ##
#################################

# png output for demonstration of bunch direction of motion
TBG_pngYX="--e_png.period 10 \
           --e_png.axis yx \
           --e_png.slicePoint 0.5 \
           --e_png.folder pngElectronsYX"

# transition radiation plugin
TBG_e_transRad="--e_transRad.period 10 \
                --e_transRad.file transRad \
                --e_transRad.foilPositionY 0.0"

# energy histogram to check amount of electrons and their velocity
TBG_e_histogram="--e_energyHistogram.period 10 \
                 --e_energyHistogram.binCount 1024 \
                 --e_energyHistogram.maxEnergy 500000 \
                 --e_energyHistogram.filter all"

# macroparticle count to see time consumption of transition radiation plugin
TBG_e_macroParticleCount="--e_macroParticlesCount.period 10"

TBG_plugins="!TBG_pngYX \
             !TBG_e_transRad \
             !TBG_e_histogram \
             !TBG_e_macroParticleCount"

#################################
## Section: Program Parameters ##
#################################

TBG_deviceDist="!TBG_devices_x !TBG_devices_y !TBG_devices_z"

TBG_programParams="-d !TBG_deviceDist \
                   -g !TBG_gridSize   \
                   -s !TBG_steps      \
                   !TBG_periodic      \
                   !TBG_plugins       \
                   --versionOnce"

# TOTAL number of devices
TBG_tasks="$(( TBG_devices_x * TBG_devices_y * TBG_devices_z ))"

"$TBG_cfgPath"/submitAction.sh
